//
// ATCApi - ƶƮ ̳  API  ϱ  
//
// ʿ  : tstring
//

#include "StdAfx.h"

#include "ATCApi.h"

#include "tstring.h"

#include "../Debug.h"

CATCApi_LL g_cATCApi;

BOOL CATCApi_LL::Init()
{
	if (IsValid()) return TRUE;

	IATCApi_LL *pATCApi_LL;

	pATCApi_LL = new CATCApi_LL_0_2;

	if (pATCApi_LL->Init())
	{
		m_pATCApi_LL = pATCApi_LL;
		return TRUE;
	}

	delete pATCApi_LL;
	pATCApi_LL = new CATCApi_LL_0_3;

	if (pATCApi_LL->Init())
	{
		m_pATCApi_LL = pATCApi_LL;
		return TRUE;
	}
	delete pATCApi_LL;

	pATCApi_LL = NULL;

	long error_code = LOWORD(GetLastError());
	if (error_code == ERROR_MOD_NOT_FOUND)
	{
		// 0.2 Ȥ 0.3  ATCTNR  ã 
		NOTIFY_ERROR(ERROR_CODE(ERROR_INVALID_ENVIRONMENT));
		SETLASTERROR(ERROR_INVALID_ENVIRONMENT);
	}
	else if (error_code != ERROR_PROC_NOT_FOUND)
	{
		// Ÿ ٸ 
		NOTIFY_ERROR(ERROR_CODE(error_code));
		SETLASTERROR(error_code);
	}
	return FALSE;
}

BOOL CATCApi_LL_0_2::Init()
{
	using namespace NS_ARALTRANS_0_2;

	if (IsValid()) return TRUE;

	ZeroMemory(&m_cEntry, sizeof(m_cEntry));

	try 
	{
		// ATCTNR.DLL  ã´
		m_hContainer=GetModuleHandle(_T("ATCTNR.DLL"));
		if (!m_hContainer)	
		{
			SETLASTERROR(ERROR_MOD_NOT_FOUND);
			return FALSE;
		}

		//  Լ ͸ ´

		m_cEntry.pfnGetCurAlgorithm=(PROC_GetCurAlgorithm)GetProcAddress(m_hContainer, "GetCurAlgorithm");
		if (!m_cEntry.pfnGetCurAlgorithm) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.pfnGetCurTranslator=(PROC_GetCurTranslator)GetProcAddress(m_hContainer, "GetCurTranslator");
		if (!m_cEntry.pfnGetCurTranslator) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.pfnHookDllFunction=(PROC_HookDllFunction)GetProcAddress(m_hContainer, "HookDllFunction");
		if (!m_cEntry.pfnHookDllFunction) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.pfnUnhookDllFunction=(PROC_UnhookDllFunction)GetProcAddress(m_hContainer, "UnhookDllFunction");
		if (!m_cEntry.pfnUnhookDllFunction) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.pfnGetOrigDllFunction=(PROC_GetOrigDllFunction)GetProcAddress(m_hContainer, "GetOrigDllFunction");
		if (!m_cEntry.pfnGetOrigDllFunction) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.pfnHookCodePoint=(PROC_HookCodePoint)GetProcAddress(m_hContainer, "HookCodePoint");
		if (!m_cEntry.pfnHookCodePoint) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.pfnUnhookCodePoint=(PROC_UnhookCodePoint)GetProcAddress(m_hContainer, "UnhookCodePoint");
		if (!m_cEntry.pfnUnhookCodePoint) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.pfnTranslateText=(PROC_TranslateText)GetProcAddress(m_hContainer, "TranslateText");
		if (!m_cEntry.pfnTranslateText) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.pfnIsAppLocaleLoaded=(PROC_IsAppLocaleLoaded)GetProcAddress(m_hContainer, "IsAppLocaleLoaded");
		if (!m_cEntry.pfnIsAppLocaleLoaded) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.pfnEnableAppLocale=(PROC_EnableAppLocale)GetProcAddress(m_hContainer, "EnableAppLocale");
		if (!m_cEntry.pfnEnableAppLocale) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		// DefATContainer.h 0.2.20081012 Ŀ ߰ Լ
		//  ȣȯ  ã ϴ 밡ϵ Ѵ.

		try 
		{
			m_cEntry.pfnSuspendAllThread=(PROC_SuspendAllThread)GetProcAddress(m_hContainer, "SuspendAllThread");
			if (!m_cEntry.pfnSuspendAllThread) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

			m_cEntry.pfnResumeAllThread=(PROC_ResumeAllThread)GetProcAddress(m_hContainer, "ResumeAllThread");
			if (!m_cEntry.pfnResumeAllThread) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

			m_cEntry.pfnIsAllThreadSuspended=(PROC_IsAllThreadSuspended)GetProcAddress(m_hContainer, "IsAllThreadSuspended");
			if (!m_cEntry.pfnIsAllThreadSuspended) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);
		}
		catch (long error_code)
		{
			SETLASTERROR(error_code);
			m_cEntry.pfnSuspendAllThread=NULL;
			m_cEntry.pfnResumeAllThread=NULL;
			m_cEntry.pfnIsAllThreadSuspended=NULL;
		}

	}
	catch(long error_code)
	{
		m_hContainer=NULL;
		MessageBox(NULL, _T("ƶƮ API  ã Ͽϴ."), _T("CATCApi"), MB_OK | MB_ICONEXCLAMATION);
		NOTIFY_ERROR(error_code);
		SETLASTERROR(error_code);
		return FALSE;
	}
	return TRUE;
}

BOOL CATCApi_LL_0_2::HookWin32Api(LPCWSTR cszDllName, LPCWSTR cszFuncName, LPVOID pfnNew, int nPriority)
{
	char szDllName[MAX_PATH], szFuncName[MAX_PATH];

	Wide2Kor(cszDllName, szDllName, MAX_PATH);
	Wide2Kor(cszFuncName, szFuncName, MAX_PATH);
	return m_cEntry.pfnHookDllFunction(szDllName, szFuncName, pfnNew);

}

BOOL CATCApi_LL_0_2::UnhookWin32Api(LPCWSTR cszDllName, LPCWSTR cszFuncName, LPVOID pfnNew)
{
	char szDllName[MAX_PATH], szFuncName[MAX_PATH];

	Wide2Kor(cszDllName, szDllName, MAX_PATH);
	Wide2Kor(cszFuncName, szFuncName, MAX_PATH);
	return m_cEntry.pfnUnhookDllFunction(szDllName, szFuncName);;

}

LPVOID CATCApi_LL_0_2::GetOrigWin32Api(LPCWSTR cszDllName, LPCWSTR cszFuncName)
{
	char szDllName[MAX_PATH], szFuncName[MAX_PATH];
	LPVOID pvfnOld = NULL;

	Wide2Kor(cszDllName, szDllName, MAX_PATH);
	Wide2Kor(cszFuncName, szFuncName, MAX_PATH);
	pvfnOld = m_cEntry.pfnGetOrigDllFunction(szDllName, szFuncName);

	if (pvfnOld == NULL) return NULL;

	return pvfnOld;
}


BOOL CATCApi_LL_0_3::Init()
{
	using namespace NS_ARALTRANS_0_3;

	if (IsValid()) return TRUE;

	ZeroMemory(&m_cEntry, sizeof(m_cEntry));

	try 
	{
		// ATCTNR.DLL  ã´
		m_hContainer=GetModuleHandle(_T("ATCTNR3.DLL"));
		if (!m_hContainer)
		{
			SETLASTERROR(ERROR_MOD_NOT_FOUND);
			return FALSE;
		}


		//  Լ ͸ ´

		m_cEntry.procHookWin32Api=(PROC_HookWin32Api)GetProcAddress(m_hContainer, "HookWin32Api");
		if (!m_cEntry.procHookWin32Api) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procUnhookWin32Api=(PROC_UnhookWin32Api)GetProcAddress(m_hContainer, "UnhookWin32Api");
		if (!m_cEntry.procUnhookWin32Api) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procHookCodePoint=(PROC_HookCodePoint)GetProcAddress(m_hContainer, "HookCodePoint");
		if (!m_cEntry.procHookCodePoint) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procUnhookCodePoint=(PROC_UnhookCodePoint)GetProcAddress(m_hContainer, "UnhookCodePoint");
		if (!m_cEntry.procUnhookCodePoint) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procCreateTransCtx=(PROC_CreateTransCtx)GetProcAddress(m_hContainer, "CreateTransCtx");
		if (!m_cEntry.procCreateTransCtx) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procDeleteTransCtx=(PROC_DeleteTransCtx)GetProcAddress(m_hContainer, "DeleteTransCtx");
		if (!m_cEntry.procDeleteTransCtx) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procTranslateUsingCtx=(PROC_TranslateUsingCtx)GetProcAddress(m_hContainer, "TranslateUsingCtx");
		if (!m_cEntry.procTranslateUsingCtx) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procIsAppLocaleLoaded=(PROC_IsAppLocaleLoaded)GetProcAddress(m_hContainer, "IsAppLocaleLoaded");
		if (!m_cEntry.procIsAppLocaleLoaded) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procSuspendAllThread=(PROC_SuspendAllThread)GetProcAddress(m_hContainer, "SuspendAllThread");
		if (!m_cEntry.procSuspendAllThread) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procResumeAllThread=(PROC_ResumeAllThread)GetProcAddress(m_hContainer, "ResumeAllThread");
		if (!m_cEntry.procResumeAllThread) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);

		m_cEntry.procIsAllThreadSuspended=(PROC_IsAllThreadSuspended)GetProcAddress(m_hContainer, "IsAllThreadSuspended");
		if (!m_cEntry.procIsAllThreadSuspended) throw ERROR_CODE(ERROR_PROC_NOT_FOUND);


	}
	catch(long error_code)
	{
		m_hContainer=NULL;
		MessageBox(NULL, _T("ƶƮ API  ã Ͽϴ."), _T("CATCApi"), MB_OK | MB_ICONEXCLAMATION);
		NOTIFY_ERROR(error_code);
		SETLASTERROR(error_code);
		return FALSE;
	}
	return TRUE;
}

LPVOID CATCApi_LL_0_3::GetOrigWin32Api(LPCWSTR cszDllName, LPCWSTR cszFuncName)
{
	char szFuncName[MAX_PATH];
	LPVOID pvfnOld=NULL;

	HMODULE hModule = GetModuleHandle(cszDllName);
	if (!hModule) 
	{
		NOTIFY_ERROR(ERROR_CODE(GetLastError()));
		SETLASTERROR(GetLastError());
		return NULL;
	}

	Wide2Kor(cszFuncName, szFuncName, MAX_PATH);

	pvfnOld = (LPVOID) GetProcAddress(hModule, szFuncName);
	if (pvfnOld == NULL)
	{
		NOTIFY_ERROR(ERROR_CODE(GetLastError()));
		SETLASTERROR(GetLastError());
		return NULL;
	}

	return pvfnOld;
}


